package org.codehaus.mojo.keytool;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.apache.maven.plugin.AbstractMojo;
import org.apache.maven.plugin.MojoExecutionException;

/**
 * Display help information on keytool-maven-plugin.<br/> Call <pre>  mvn keytool:help -Ddetail=true -Dgoal=&lt;goal-name&gt;</pre> to display parameter details.
 *
 * @version generated on Mon Apr 09 21:12:54 CEST 2012
 * @author org.apache.maven.tools.plugin.generator.PluginHelpGenerator (version 2.9)
 * @goal help
 * @requiresProject false
 * @threadSafe
 */
public class HelpMojo
    extends AbstractMojo
{
    /**
     * If <code>true</code>, display all settable properties for each goal.
     * 
     * @parameter expression="${detail}" default-value="false"
     */
    private boolean detail;

    /**
     * The name of the goal for which to show help. If unspecified, all goals will be displayed.
     * 
     * @parameter expression="${goal}"
     */
    private java.lang.String goal;

    /**
     * The maximum length of a display line, should be positive.
     * 
     * @parameter expression="${lineLength}" default-value="80"
     */
    private int lineLength;

    /**
     * The number of spaces per indentation level, should be positive.
     * 
     * @parameter expression="${indentSize}" default-value="2"
     */
    private int indentSize;


    /** {@inheritDoc} */
    public void execute()
        throws MojoExecutionException
    {
        if ( lineLength <= 0 )
        {
            getLog().warn( "The parameter 'lineLength' should be positive, using '80' as default." );
            lineLength = 80;
        }
        if ( indentSize <= 0 )
        {
            getLog().warn( "The parameter 'indentSize' should be positive, using '2' as default." );
            indentSize = 2;
        }

        StringBuffer sb = new StringBuffer();

        append( sb, "org.codehaus.mojo:keytool-maven-plugin:1.2", 0 );
        append( sb, "", 0 );

        append( sb, "Keytool: Maven Plugin", 0 );
        append( sb, "A plugin that wraps the keytool program bundled with Sun\'s Java SDK. Allows to manipulate keystores.", 1 );
        append( sb, "", 0 );

        if ( goal == null || goal.length() <= 0 )
        {
            append( sb, "This plugin has 20 goals:", 0 );
            append( sb, "", 0 );
        }

        if ( goal == null || goal.length() <= 0 || "changeAlias".equals( goal ) )
        {
            append( sb, "keytool:changeAlias", 0 );
            append( sb, "To change an entry alias into a keystore. Implemented as a wrapper around the SDK keytool -keyclone (jdk 1.5) or keytool -changealias (jdk 1.6) command. See keystore documentation.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "alias", 2 );
                append( sb, "Alias name of the entry to process. See options.", 3 );
                append( sb, "Expression: ${alias}", 3 );
                append( sb, "", 0 );

                append( sb, "arguments", 2 );
                append( sb, "List of additional arguments to append to the keytool command line. Note: This parameter is left for compatibility reason but should be used at a last resort whenparameters are not found in dedicated mojo due to possible side-effects on parameters (see https://jira.codehaus.org/browse/MKEYTOOL-17)", 3 );
                append( sb, "Expression: ${keytool.arguments}", 3 );
                append( sb, "", 0 );

                append( sb, "destalias", 2 );
                append( sb, "Destination alias. See options.", 3 );
                append( sb, "Expression: ${destalias}", 3 );
                append( sb, "", 0 );

                append( sb, "keypass", 2 );
                append( sb, "Key password. See options.", 3 );
                append( sb, "Expression: ${keypass}", 3 );
                append( sb, "", 0 );

                append( sb, "keystore", 2 );
                append( sb, "Keystore location. See options.", 3 );
                append( sb, "Expression: ${keystore}", 3 );
                append( sb, "", 0 );

                append( sb, "passwordProtected", 2 );
                append( sb, "Password through protected mechanism. See options.", 3 );
                append( sb, "Expression: ${passwordProtected}", 3 );
                append( sb, "", 0 );

                append( sb, "providerarg", 2 );
                append( sb, "Provider argument. See options.", 3 );
                append( sb, "Expression: ${providerarg}", 3 );
                append( sb, "", 0 );

                append( sb, "providerclass", 2 );
                append( sb, "Provider class name. See options.", 3 );
                append( sb, "Expression: ${providerclass}", 3 );
                append( sb, "", 0 );

                append( sb, "providername", 2 );
                append( sb, "Provider name. See options.", 3 );
                append( sb, "Expression: ${providername}", 3 );
                append( sb, "", 0 );

                append( sb, "providerpath", 2 );
                append( sb, "Provider classpath. See options.", 3 );
                append( sb, "Expression: ${providerpath}", 3 );
                append( sb, "", 0 );

                append( sb, "skip (Default: false)", 2 );
                append( sb, "Set to true to disable the plugin.", 3 );
                append( sb, "Expression: ${keytool.skip}", 3 );
                append( sb, "", 0 );

                append( sb, "storepass", 2 );
                append( sb, "Keystore password. See options.", 3 );
                append( sb, "Expression: ${storepass}", 3 );
                append( sb, "", 0 );

                append( sb, "storetype", 2 );
                append( sb, "Keystore type. See options.", 3 );
                append( sb, "Expression: ${storetype}", 3 );
                append( sb, "", 0 );

                append( sb, "verbose (Default: false)", 2 );
                append( sb, "Enable verbose mode (in mojo and in keytool command). See options.", 3 );
                append( sb, "Expression: ${verbose}", 3 );
                append( sb, "", 0 );

                append( sb, "workingDirectory (Default: ${basedir})", 2 );
                append( sb, "Where to execute the keytool command.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${keytool.workingdir}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "changeKeyPassword".equals( goal ) )
        {
            append( sb, "keytool:changeKeyPassword", 0 );
            append( sb, "To change the key password of an entry of a keystore. Implemented as a wrapper around the SDK keytool -keypasswd command. See keystore documentation.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "alias", 2 );
                append( sb, "Alias name of the entry to process. See options.", 3 );
                append( sb, "Expression: ${alias}", 3 );
                append( sb, "", 0 );

                append( sb, "arguments", 2 );
                append( sb, "List of additional arguments to append to the keytool command line. Note: This parameter is left for compatibility reason but should be used at a last resort whenparameters are not found in dedicated mojo due to possible side-effects on parameters (see https://jira.codehaus.org/browse/MKEYTOOL-17)", 3 );
                append( sb, "Expression: ${keytool.arguments}", 3 );
                append( sb, "", 0 );

                append( sb, "keypass", 2 );
                append( sb, "Key password. See options.", 3 );
                append( sb, "Expression: ${keypass}", 3 );
                append( sb, "", 0 );

                append( sb, "keystore", 2 );
                append( sb, "Keystore location. See options.", 3 );
                append( sb, "Expression: ${keystore}", 3 );
                append( sb, "", 0 );

                append( sb, "newPassword", 2 );
                append( sb, "New password. See options.", 3 );
                append( sb, "Expression: ${newPassword}", 3 );
                append( sb, "", 0 );

                append( sb, "passwordProtected", 2 );
                append( sb, "Password through protected mechanism. See options.", 3 );
                append( sb, "Expression: ${passwordProtected}", 3 );
                append( sb, "", 0 );

                append( sb, "providerarg", 2 );
                append( sb, "Provider argument. See options.", 3 );
                append( sb, "Expression: ${providerarg}", 3 );
                append( sb, "", 0 );

                append( sb, "providerclass", 2 );
                append( sb, "Provider class name. See options.", 3 );
                append( sb, "Expression: ${providerclass}", 3 );
                append( sb, "", 0 );

                append( sb, "providername", 2 );
                append( sb, "Provider name. See options.", 3 );
                append( sb, "Expression: ${providername}", 3 );
                append( sb, "", 0 );

                append( sb, "providerpath", 2 );
                append( sb, "Provider classpath. See options.", 3 );
                append( sb, "Expression: ${providerpath}", 3 );
                append( sb, "", 0 );

                append( sb, "skip (Default: false)", 2 );
                append( sb, "Set to true to disable the plugin.", 3 );
                append( sb, "Expression: ${keytool.skip}", 3 );
                append( sb, "", 0 );

                append( sb, "storepass", 2 );
                append( sb, "Keystore password. See options.", 3 );
                append( sb, "Expression: ${storepass}", 3 );
                append( sb, "", 0 );

                append( sb, "storetype", 2 );
                append( sb, "Keystore type. See options.", 3 );
                append( sb, "Expression: ${storetype}", 3 );
                append( sb, "", 0 );

                append( sb, "verbose (Default: false)", 2 );
                append( sb, "Enable verbose mode (in mojo and in keytool command). See options.", 3 );
                append( sb, "Expression: ${verbose}", 3 );
                append( sb, "", 0 );

                append( sb, "workingDirectory (Default: ${basedir})", 2 );
                append( sb, "Where to execute the keytool command.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${keytool.workingdir}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "changeStorePassword".equals( goal ) )
        {
            append( sb, "keytool:changeStorePassword", 0 );
            append( sb, "To change the store password of a keystore. Implemented as a wrapper around the SDK keytool -storepasswd command. See keystore documentation.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "arguments", 2 );
                append( sb, "List of additional arguments to append to the keytool command line. Note: This parameter is left for compatibility reason but should be used at a last resort whenparameters are not found in dedicated mojo due to possible side-effects on parameters (see https://jira.codehaus.org/browse/MKEYTOOL-17)", 3 );
                append( sb, "Expression: ${keytool.arguments}", 3 );
                append( sb, "", 0 );

                append( sb, "keystore", 2 );
                append( sb, "Keystore location. See options.", 3 );
                append( sb, "Expression: ${keystore}", 3 );
                append( sb, "", 0 );

                append( sb, "newPassword", 2 );
                append( sb, "New password. See options.", 3 );
                append( sb, "Expression: ${newPassword}", 3 );
                append( sb, "", 0 );

                append( sb, "providerarg", 2 );
                append( sb, "Provider argument. See options.", 3 );
                append( sb, "Expression: ${providerarg}", 3 );
                append( sb, "", 0 );

                append( sb, "providerclass", 2 );
                append( sb, "Provider class name. See options.", 3 );
                append( sb, "Expression: ${providerclass}", 3 );
                append( sb, "", 0 );

                append( sb, "providername", 2 );
                append( sb, "Provider name. See options.", 3 );
                append( sb, "Expression: ${providername}", 3 );
                append( sb, "", 0 );

                append( sb, "providerpath", 2 );
                append( sb, "Provider classpath. See options.", 3 );
                append( sb, "Expression: ${providerpath}", 3 );
                append( sb, "", 0 );

                append( sb, "skip (Default: false)", 2 );
                append( sb, "Set to true to disable the plugin.", 3 );
                append( sb, "Expression: ${keytool.skip}", 3 );
                append( sb, "", 0 );

                append( sb, "storepass", 2 );
                append( sb, "Keystore password. See options.", 3 );
                append( sb, "Expression: ${storepass}", 3 );
                append( sb, "", 0 );

                append( sb, "storetype", 2 );
                append( sb, "Keystore type. See options.", 3 );
                append( sb, "Expression: ${storetype}", 3 );
                append( sb, "", 0 );

                append( sb, "verbose (Default: false)", 2 );
                append( sb, "Enable verbose mode (in mojo and in keytool command). See options.", 3 );
                append( sb, "Expression: ${verbose}", 3 );
                append( sb, "", 0 );

                append( sb, "workingDirectory (Default: ${basedir})", 2 );
                append( sb, "Where to execute the keytool command.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${keytool.workingdir}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "clean".equals( goal ) )
        {
            append( sb, "keytool:clean", 0 );
            append( sb, "A Mojo that deletes a generated keystore file.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "keystore", 2 );
                append( sb, "See options.", 3 );
                append( sb, "Expression: ${keystore}", 3 );
                append( sb, "", 0 );

                append( sb, "skip (Default: false)", 2 );
                append( sb, "Set to true to disable the plugin.", 3 );
                append( sb, "Expression: ${keytool.skip}", 3 );
                append( sb, "", 0 );

                append( sb, "verbose (Default: false)", 2 );
                append( sb, "Enable verbose mode (in mojo and in keytool command). See options.", 3 );
                append( sb, "Expression: ${verbose}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "deleteAlias".equals( goal ) )
        {
            append( sb, "keytool:deleteAlias", 0 );
            append( sb, "To delete an entry alias from a keystore. Implemented as a wrapper around the SDK keytool -delete command. See keystore documentation.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "alias", 2 );
                append( sb, "Alias name of the entry to process. See options.", 3 );
                append( sb, "Expression: ${alias}", 3 );
                append( sb, "", 0 );

                append( sb, "arguments", 2 );
                append( sb, "List of additional arguments to append to the keytool command line. Note: This parameter is left for compatibility reason but should be used at a last resort whenparameters are not found in dedicated mojo due to possible side-effects on parameters (see https://jira.codehaus.org/browse/MKEYTOOL-17)", 3 );
                append( sb, "Expression: ${keytool.arguments}", 3 );
                append( sb, "", 0 );

                append( sb, "keystore", 2 );
                append( sb, "Keystore location. See options.", 3 );
                append( sb, "Expression: ${keystore}", 3 );
                append( sb, "", 0 );

                append( sb, "passwordProtected", 2 );
                append( sb, "Password through protected mechanism. See options.", 3 );
                append( sb, "Expression: ${passwordProtected}", 3 );
                append( sb, "", 0 );

                append( sb, "providerarg", 2 );
                append( sb, "Provider argument. See options.", 3 );
                append( sb, "Expression: ${providerarg}", 3 );
                append( sb, "", 0 );

                append( sb, "providerclass", 2 );
                append( sb, "Provider class name. See options.", 3 );
                append( sb, "Expression: ${providerclass}", 3 );
                append( sb, "", 0 );

                append( sb, "providername", 2 );
                append( sb, "Provider name. See options.", 3 );
                append( sb, "Expression: ${providername}", 3 );
                append( sb, "", 0 );

                append( sb, "providerpath", 2 );
                append( sb, "Provider classpath. See options.", 3 );
                append( sb, "Expression: ${providerpath}", 3 );
                append( sb, "", 0 );

                append( sb, "skip (Default: false)", 2 );
                append( sb, "Set to true to disable the plugin.", 3 );
                append( sb, "Expression: ${keytool.skip}", 3 );
                append( sb, "", 0 );

                append( sb, "storepass", 2 );
                append( sb, "Keystore password. See options.", 3 );
                append( sb, "Expression: ${storepass}", 3 );
                append( sb, "", 0 );

                append( sb, "storetype", 2 );
                append( sb, "Keystore type. See options.", 3 );
                append( sb, "Expression: ${storetype}", 3 );
                append( sb, "", 0 );

                append( sb, "verbose (Default: false)", 2 );
                append( sb, "Enable verbose mode (in mojo and in keytool command). See options.", 3 );
                append( sb, "Expression: ${verbose}", 3 );
                append( sb, "", 0 );

                append( sb, "workingDirectory (Default: ${basedir})", 2 );
                append( sb, "Where to execute the keytool command.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${keytool.workingdir}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "export".equals( goal ) )
        {
            append( sb, "keytool:export", 0 );
            append( sb, "Deprecated. since 1.2, use now the exportCertificate mojo.", 1 );
            if ( detail )
            {
                append( sb, "", 0 );
                append( sb, "Reads (from the keystore) the certificate associated with alias, and stores it in the file cert_file. Implemented as a wrapper around the SDK keytool -export command.\n-export\u00a0\u00a0\u00a0[-v]\u00a0[-protected]\n[-alias\u00a0<alias>]\n[-file\u00a0<file>]\n[-storetype\u00a0<storetype>]\n[-keystore\u00a0<keystore>]\n[-storepass\u00a0<storepass>]\nSee keystore documentation.", 1 );
            }
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "alias", 2 );
                append( sb, "See options.", 3 );
                append( sb, "Expression: ${alias}", 3 );
                append( sb, "", 0 );

                append( sb, "arguments", 2 );
                append( sb, "List of additional arguments to append to the keytool command line.", 3 );
                append( sb, "Expression: ${keytool.arguments}", 3 );
                append( sb, "", 0 );

                append( sb, "file", 2 );
                append( sb, "See options.", 3 );
                append( sb, "Expression: ${file}", 3 );
                append( sb, "", 0 );

                append( sb, "keystore", 2 );
                append( sb, "See options.", 3 );
                append( sb, "Expression: ${keystore}", 3 );
                append( sb, "", 0 );

                append( sb, "skip (Default: false)", 2 );
                append( sb, "Set to true to disable the plugin.", 3 );
                append( sb, "Expression: ${keytool.skip}", 3 );
                append( sb, "", 0 );

                append( sb, "storepass", 2 );
                append( sb, "See options.", 3 );
                append( sb, "Expression: ${storepass}", 3 );
                append( sb, "", 0 );

                append( sb, "storetype", 2 );
                append( sb, "See options.", 3 );
                append( sb, "Expression: ${storetype}", 3 );
                append( sb, "", 0 );

                append( sb, "verbose (Default: false)", 2 );
                append( sb, "Enable verbose. See options.", 3 );
                append( sb, "Expression: ${verbose}", 3 );
                append( sb, "", 0 );

                append( sb, "workingDirectory (Default: ${basedir})", 2 );
                append( sb, "Where to execute the keytool command.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${keytool.workingdir}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "exportCertificate".equals( goal ) )
        {
            append( sb, "keytool:exportCertificate", 0 );
            append( sb, "To export a certificate from a keystore. Implemented as a wrapper around the SDK keytool -export command. See keystore documentation.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "alias", 2 );
                append( sb, "Alias name of the entry to process. See options.", 3 );
                append( sb, "Expression: ${alias}", 3 );
                append( sb, "", 0 );

                append( sb, "arguments", 2 );
                append( sb, "List of additional arguments to append to the keytool command line. Note: This parameter is left for compatibility reason but should be used at a last resort whenparameters are not found in dedicated mojo due to possible side-effects on parameters (see https://jira.codehaus.org/browse/MKEYTOOL-17)", 3 );
                append( sb, "Expression: ${keytool.arguments}", 3 );
                append( sb, "", 0 );

                append( sb, "file", 2 );
                append( sb, "Output file name. See options.", 3 );
                append( sb, "Expression: ${file}", 3 );
                append( sb, "", 0 );

                append( sb, "keystore", 2 );
                append( sb, "Keystore location. See options.", 3 );
                append( sb, "Expression: ${keystore}", 3 );
                append( sb, "", 0 );

                append( sb, "passwordProtected", 2 );
                append( sb, "Password through protected mechanism. See options.", 3 );
                append( sb, "Expression: ${passwordProtected}", 3 );
                append( sb, "", 0 );

                append( sb, "providerarg", 2 );
                append( sb, "Provider argument. See options.", 3 );
                append( sb, "Expression: ${providerarg}", 3 );
                append( sb, "", 0 );

                append( sb, "providerclass", 2 );
                append( sb, "Provider class name. See options.", 3 );
                append( sb, "Expression: ${providerclass}", 3 );
                append( sb, "", 0 );

                append( sb, "providername", 2 );
                append( sb, "Provider name. See options.", 3 );
                append( sb, "Expression: ${providername}", 3 );
                append( sb, "", 0 );

                append( sb, "providerpath", 2 );
                append( sb, "Provider classpath. See options.", 3 );
                append( sb, "Expression: ${providerpath}", 3 );
                append( sb, "", 0 );

                append( sb, "rfc", 2 );
                append( sb, "Output in RFC style. See options.", 3 );
                append( sb, "Expression: ${rfc}", 3 );
                append( sb, "", 0 );

                append( sb, "skip (Default: false)", 2 );
                append( sb, "Set to true to disable the plugin.", 3 );
                append( sb, "Expression: ${keytool.skip}", 3 );
                append( sb, "", 0 );

                append( sb, "storepass", 2 );
                append( sb, "Keystore password. See options.", 3 );
                append( sb, "Expression: ${storepass}", 3 );
                append( sb, "", 0 );

                append( sb, "storetype", 2 );
                append( sb, "Keystore type. See options.", 3 );
                append( sb, "Expression: ${storetype}", 3 );
                append( sb, "", 0 );

                append( sb, "verbose (Default: false)", 2 );
                append( sb, "Enable verbose mode (in mojo and in keytool command). See options.", 3 );
                append( sb, "Expression: ${verbose}", 3 );
                append( sb, "", 0 );

                append( sb, "workingDirectory (Default: ${basedir})", 2 );
                append( sb, "Where to execute the keytool command.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${keytool.workingdir}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "generateCertificate".equals( goal ) )
        {
            append( sb, "keytool:generateCertificate", 0 );
            append( sb, "To generate certificate from a certificate request from a keystore. Implemented as a wrapper around the SDK keytool -gencert command. See keystore documentation.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "alias", 2 );
                append( sb, "Alias name of the entry to process. See options.", 3 );
                append( sb, "Expression: ${alias}", 3 );
                append( sb, "", 0 );

                append( sb, "arguments", 2 );
                append( sb, "List of additional arguments to append to the keytool command line. Note: This parameter is left for compatibility reason but should be used at a last resort whenparameters are not found in dedicated mojo due to possible side-effects on parameters (see https://jira.codehaus.org/browse/MKEYTOOL-17)", 3 );
                append( sb, "Expression: ${keytool.arguments}", 3 );
                append( sb, "", 0 );

                append( sb, "dname", 2 );
                append( sb, "Distinguished name. See options.", 3 );
                append( sb, "Expression: ${dname}", 3 );
                append( sb, "", 0 );

                append( sb, "ext", 2 );
                append( sb, "X.509 extension. See options.", 3 );
                append( sb, "Expression: ${ext}", 3 );
                append( sb, "", 0 );

                append( sb, "infile", 2 );
                append( sb, "input file name. See options.", 3 );
                append( sb, "Expression: ${infile}", 3 );
                append( sb, "", 0 );

                append( sb, "keypass", 2 );
                append( sb, "Key password. See options.", 3 );
                append( sb, "Expression: ${keypass}", 3 );
                append( sb, "", 0 );

                append( sb, "keystore", 2 );
                append( sb, "Keystore location. See options.", 3 );
                append( sb, "Expression: ${keystore}", 3 );
                append( sb, "", 0 );

                append( sb, "outfile", 2 );
                append( sb, "output file name. See options.", 3 );
                append( sb, "Expression: ${outfile}", 3 );
                append( sb, "", 0 );

                append( sb, "passwordProtected", 2 );
                append( sb, "Password through protected mechanism. See options.", 3 );
                append( sb, "Expression: ${passwordProtected}", 3 );
                append( sb, "", 0 );

                append( sb, "providerarg", 2 );
                append( sb, "Provider argument. See options.", 3 );
                append( sb, "Expression: ${providerarg}", 3 );
                append( sb, "", 0 );

                append( sb, "providerclass", 2 );
                append( sb, "Provider class name. See options.", 3 );
                append( sb, "Expression: ${providerclass}", 3 );
                append( sb, "", 0 );

                append( sb, "providername", 2 );
                append( sb, "Provider name. See options.", 3 );
                append( sb, "Expression: ${providername}", 3 );
                append( sb, "", 0 );

                append( sb, "providerpath", 2 );
                append( sb, "Provider classpath. See options.", 3 );
                append( sb, "Expression: ${providerpath}", 3 );
                append( sb, "", 0 );

                append( sb, "rfc", 2 );
                append( sb, "Output in RFC style. See options.", 3 );
                append( sb, "Expression: ${rfc}", 3 );
                append( sb, "", 0 );

                append( sb, "sigalg", 2 );
                append( sb, "Signature algorithm name. See options.", 3 );
                append( sb, "Expression: ${sigalg}", 3 );
                append( sb, "", 0 );

                append( sb, "skip (Default: false)", 2 );
                append( sb, "Set to true to disable the plugin.", 3 );
                append( sb, "Expression: ${keytool.skip}", 3 );
                append( sb, "", 0 );

                append( sb, "startdate", 2 );
                append( sb, "Certificate validity start date/time. See options.", 3 );
                append( sb, "Expression: ${startdate}", 3 );
                append( sb, "", 0 );

                append( sb, "storepass", 2 );
                append( sb, "Keystore password. See options.", 3 );
                append( sb, "Expression: ${storepass}", 3 );
                append( sb, "", 0 );

                append( sb, "storetype", 2 );
                append( sb, "Keystore type. See options.", 3 );
                append( sb, "Expression: ${storetype}", 3 );
                append( sb, "", 0 );

                append( sb, "validity", 2 );
                append( sb, "Validity number of days. See options.", 3 );
                append( sb, "Expression: ${validity}", 3 );
                append( sb, "", 0 );

                append( sb, "verbose (Default: false)", 2 );
                append( sb, "Enable verbose mode (in mojo and in keytool command). See options.", 3 );
                append( sb, "Expression: ${verbose}", 3 );
                append( sb, "", 0 );

                append( sb, "workingDirectory (Default: ${basedir})", 2 );
                append( sb, "Where to execute the keytool command.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${keytool.workingdir}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "generateCertificateRequest".equals( goal ) )
        {
            append( sb, "keytool:generateCertificateRequest", 0 );
            append( sb, "To generate certificate request. Implemented as a wrapper around the SDK keytool -certreq command. See keystore documentation.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "alias", 2 );
                append( sb, "Alias name of the entry to process. See options.", 3 );
                append( sb, "Expression: ${alias}", 3 );
                append( sb, "", 0 );

                append( sb, "arguments", 2 );
                append( sb, "List of additional arguments to append to the keytool command line. Note: This parameter is left for compatibility reason but should be used at a last resort whenparameters are not found in dedicated mojo due to possible side-effects on parameters (see https://jira.codehaus.org/browse/MKEYTOOL-17)", 3 );
                append( sb, "Expression: ${keytool.arguments}", 3 );
                append( sb, "", 0 );

                append( sb, "dname", 2 );
                append( sb, "Distinguished name. See options.", 3 );
                append( sb, "Expression: ${dname}", 3 );
                append( sb, "", 0 );

                append( sb, "file", 2 );
                append( sb, "Output file name. See options.", 3 );
                append( sb, "Expression: ${infile}", 3 );
                append( sb, "", 0 );

                append( sb, "keypass", 2 );
                append( sb, "Key password. See options.", 3 );
                append( sb, "Expression: ${keypass}", 3 );
                append( sb, "", 0 );

                append( sb, "keystore", 2 );
                append( sb, "Keystore location. See options.", 3 );
                append( sb, "Expression: ${keystore}", 3 );
                append( sb, "", 0 );

                append( sb, "passwordProtected", 2 );
                append( sb, "Password through protected mechanism. See options.", 3 );
                append( sb, "Expression: ${passwordProtected}", 3 );
                append( sb, "", 0 );

                append( sb, "providerarg", 2 );
                append( sb, "Provider argument. See options.", 3 );
                append( sb, "Expression: ${providerarg}", 3 );
                append( sb, "", 0 );

                append( sb, "providerclass", 2 );
                append( sb, "Provider class name. See options.", 3 );
                append( sb, "Expression: ${providerclass}", 3 );
                append( sb, "", 0 );

                append( sb, "providername", 2 );
                append( sb, "Provider name. See options.", 3 );
                append( sb, "Expression: ${providername}", 3 );
                append( sb, "", 0 );

                append( sb, "providerpath", 2 );
                append( sb, "Provider classpath. See options.", 3 );
                append( sb, "Expression: ${providerpath}", 3 );
                append( sb, "", 0 );

                append( sb, "sigalg", 2 );
                append( sb, "Signature algorithm name. See options.", 3 );
                append( sb, "Expression: ${sigalg}", 3 );
                append( sb, "", 0 );

                append( sb, "skip (Default: false)", 2 );
                append( sb, "Set to true to disable the plugin.", 3 );
                append( sb, "Expression: ${keytool.skip}", 3 );
                append( sb, "", 0 );

                append( sb, "storepass", 2 );
                append( sb, "Keystore password. See options.", 3 );
                append( sb, "Expression: ${storepass}", 3 );
                append( sb, "", 0 );

                append( sb, "storetype", 2 );
                append( sb, "Keystore type. See options.", 3 );
                append( sb, "Expression: ${storetype}", 3 );
                append( sb, "", 0 );

                append( sb, "verbose (Default: false)", 2 );
                append( sb, "Enable verbose mode (in mojo and in keytool command). See options.", 3 );
                append( sb, "Expression: ${verbose}", 3 );
                append( sb, "", 0 );

                append( sb, "workingDirectory (Default: ${basedir})", 2 );
                append( sb, "Where to execute the keytool command.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${keytool.workingdir}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "generateKeyPair".equals( goal ) )
        {
            append( sb, "keytool:generateKeyPair", 0 );
            append( sb, "To generate a key pair into a keystore. Implemented as a wrapper around the SDK keytool -genkey (jdk 1.5) keytool -genkeypair (jdk 1.6) command. See keystore documentation.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "alias", 2 );
                append( sb, "Alias name of the entry to process. See options.", 3 );
                append( sb, "Expression: ${alias}", 3 );
                append( sb, "", 0 );

                append( sb, "arguments", 2 );
                append( sb, "List of additional arguments to append to the keytool command line. Note: This parameter is left for compatibility reason but should be used at a last resort whenparameters are not found in dedicated mojo due to possible side-effects on parameters (see https://jira.codehaus.org/browse/MKEYTOOL-17)", 3 );
                append( sb, "Expression: ${keytool.arguments}", 3 );
                append( sb, "", 0 );

                append( sb, "dname", 2 );
                append( sb, "Distinguished name. See options.", 3 );
                append( sb, "Expression: ${dname}", 3 );
                append( sb, "", 0 );

                append( sb, "ext", 2 );
                append( sb, "X.509 extension. See options.", 3 );
                append( sb, "Expression: ${ext}", 3 );
                append( sb, "", 0 );

                append( sb, "keyalg", 2 );
                append( sb, "Key algorithm name. See options.", 3 );
                append( sb, "Expression: ${keyalg}", 3 );
                append( sb, "", 0 );

                append( sb, "keypass", 2 );
                append( sb, "Key password. See options.", 3 );
                append( sb, "Expression: ${keypass}", 3 );
                append( sb, "", 0 );

                append( sb, "keysize", 2 );
                append( sb, "Key bit size. See options.", 3 );
                append( sb, "Expression: ${keysize}", 3 );
                append( sb, "", 0 );

                append( sb, "keystore", 2 );
                append( sb, "Keystore location. See options.", 3 );
                append( sb, "Expression: ${keystore}", 3 );
                append( sb, "", 0 );

                append( sb, "passwordProtected", 2 );
                append( sb, "Password through protected mechanism. See options.", 3 );
                append( sb, "Expression: ${passwordProtected}", 3 );
                append( sb, "", 0 );

                append( sb, "providerarg", 2 );
                append( sb, "Provider argument. See options.", 3 );
                append( sb, "Expression: ${providerarg}", 3 );
                append( sb, "", 0 );

                append( sb, "providerclass", 2 );
                append( sb, "Provider class name. See options.", 3 );
                append( sb, "Expression: ${providerclass}", 3 );
                append( sb, "", 0 );

                append( sb, "providername", 2 );
                append( sb, "Provider name. See options.", 3 );
                append( sb, "Expression: ${providername}", 3 );
                append( sb, "", 0 );

                append( sb, "providerpath", 2 );
                append( sb, "Provider classpath. See options.", 3 );
                append( sb, "Expression: ${providerpath}", 3 );
                append( sb, "", 0 );

                append( sb, "sigalg", 2 );
                append( sb, "Signature algorithm name. See options.", 3 );
                append( sb, "Expression: ${sigalg}", 3 );
                append( sb, "", 0 );

                append( sb, "skip (Default: false)", 2 );
                append( sb, "Set to true to disable the plugin.", 3 );
                append( sb, "Expression: ${keytool.skip}", 3 );
                append( sb, "", 0 );

                append( sb, "startdate", 2 );
                append( sb, "Certificate validity start date/time. See options.", 3 );
                append( sb, "Expression: ${startdate}", 3 );
                append( sb, "", 0 );

                append( sb, "storepass", 2 );
                append( sb, "Keystore password. See options.", 3 );
                append( sb, "Expression: ${storepass}", 3 );
                append( sb, "", 0 );

                append( sb, "storetype", 2 );
                append( sb, "Keystore type. See options.", 3 );
                append( sb, "Expression: ${storetype}", 3 );
                append( sb, "", 0 );

                append( sb, "validity", 2 );
                append( sb, "Validity number of days. See options.", 3 );
                append( sb, "Expression: ${validity}", 3 );
                append( sb, "", 0 );

                append( sb, "verbose (Default: false)", 2 );
                append( sb, "Enable verbose mode (in mojo and in keytool command). See options.", 3 );
                append( sb, "Expression: ${verbose}", 3 );
                append( sb, "", 0 );

                append( sb, "workingDirectory (Default: ${basedir})", 2 );
                append( sb, "Where to execute the keytool command.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${keytool.workingdir}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "generateSecretKey".equals( goal ) )
        {
            append( sb, "keytool:generateSecretKey", 0 );
            append( sb, "To generate a secret key into a keystore. Implemented as a wrapper around the SDK keytool -genseckey command. See keystore documentation.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "alias", 2 );
                append( sb, "Alias name of the entry to process. See options.", 3 );
                append( sb, "Expression: ${alias}", 3 );
                append( sb, "", 0 );

                append( sb, "arguments", 2 );
                append( sb, "List of additional arguments to append to the keytool command line. Note: This parameter is left for compatibility reason but should be used at a last resort whenparameters are not found in dedicated mojo due to possible side-effects on parameters (see https://jira.codehaus.org/browse/MKEYTOOL-17)", 3 );
                append( sb, "Expression: ${keytool.arguments}", 3 );
                append( sb, "", 0 );

                append( sb, "keyalg", 2 );
                append( sb, "Key algorithm name. See options.", 3 );
                append( sb, "Expression: ${keyalg}", 3 );
                append( sb, "", 0 );

                append( sb, "keypass", 2 );
                append( sb, "Key password. See options.", 3 );
                append( sb, "Expression: ${keypass}", 3 );
                append( sb, "", 0 );

                append( sb, "keysize", 2 );
                append( sb, "Key bit size. See options.", 3 );
                append( sb, "Expression: ${keysize}", 3 );
                append( sb, "", 0 );

                append( sb, "keystore", 2 );
                append( sb, "Keystore location. See options.", 3 );
                append( sb, "Expression: ${keystore}", 3 );
                append( sb, "", 0 );

                append( sb, "passwordProtected", 2 );
                append( sb, "Password through protected mechanism. See options.", 3 );
                append( sb, "Expression: ${passwordProtected}", 3 );
                append( sb, "", 0 );

                append( sb, "providerarg", 2 );
                append( sb, "Provider argument. See options.", 3 );
                append( sb, "Expression: ${providerarg}", 3 );
                append( sb, "", 0 );

                append( sb, "providerclass", 2 );
                append( sb, "Provider class name. See options.", 3 );
                append( sb, "Expression: ${providerclass}", 3 );
                append( sb, "", 0 );

                append( sb, "providername", 2 );
                append( sb, "Provider name. See options.", 3 );
                append( sb, "Expression: ${providername}", 3 );
                append( sb, "", 0 );

                append( sb, "providerpath", 2 );
                append( sb, "Provider classpath. See options.", 3 );
                append( sb, "Expression: ${providerpath}", 3 );
                append( sb, "", 0 );

                append( sb, "skip (Default: false)", 2 );
                append( sb, "Set to true to disable the plugin.", 3 );
                append( sb, "Expression: ${keytool.skip}", 3 );
                append( sb, "", 0 );

                append( sb, "storepass", 2 );
                append( sb, "Keystore password. See options.", 3 );
                append( sb, "Expression: ${storepass}", 3 );
                append( sb, "", 0 );

                append( sb, "storetype", 2 );
                append( sb, "Keystore type. See options.", 3 );
                append( sb, "Expression: ${storetype}", 3 );
                append( sb, "", 0 );

                append( sb, "verbose (Default: false)", 2 );
                append( sb, "Enable verbose mode (in mojo and in keytool command). See options.", 3 );
                append( sb, "Expression: ${verbose}", 3 );
                append( sb, "", 0 );

                append( sb, "workingDirectory (Default: ${basedir})", 2 );
                append( sb, "Where to execute the keytool command.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${keytool.workingdir}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "genkey".equals( goal ) )
        {
            append( sb, "keytool:genkey", 0 );
            append( sb, "Deprecated. since 1.2, use now the generateKeyPair mojo instead.", 1 );
            if ( detail )
            {
                append( sb, "", 0 );
                append( sb, "Generates a keystore. Implemented as a wrapper around the SDK keytool -genkey command.\n-genkey\u00a0\u00a0\u00a0[-v]\u00a0[-protected]\n[-alias\u00a0<alias>]\n[-keyalg\u00a0<keyalg>]\u00a0[-keysize\u00a0<keysize>]\n[-sigalg\u00a0<sigalg>]\u00a0[-dname\u00a0<dname>]\n[-validity\u00a0<valDays>]\u00a0[-keypass\u00a0<keypass>]\n[-keystore\u00a0<keystore>]\u00a0[-storepass\u00a0<storepass>]\n[-storetype\u00a0<storetype>]\u00a0[-providerName\u00a0<name>]\n[-providerClass\u00a0<provider_class_name>\u00a0[-providerArg\u00a0<arg>]]\u00a0...\nSee keystore documentation.", 1 );
            }
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "alias", 2 );
                append( sb, "See options.", 3 );
                append( sb, "Expression: ${alias}", 3 );
                append( sb, "", 0 );

                append( sb, "arguments", 2 );
                append( sb, "List of additional arguments to append to the keytool command line.", 3 );
                append( sb, "Expression: ${keytool.arguments}", 3 );
                append( sb, "", 0 );

                append( sb, "dname", 2 );
                append( sb, "See options.", 3 );
                append( sb, "Expression: ${dname}", 3 );
                append( sb, "", 0 );

                append( sb, "keyalg", 2 );
                append( sb, "See options.", 3 );
                append( sb, "Expression: ${keyalg}", 3 );
                append( sb, "", 0 );

                append( sb, "keypass", 2 );
                append( sb, "See options.", 3 );
                append( sb, "Expression: ${keypass}", 3 );
                append( sb, "", 0 );

                append( sb, "keysize", 2 );
                append( sb, "See options.", 3 );
                append( sb, "Expression: ${keysize}", 3 );
                append( sb, "", 0 );

                append( sb, "keystore", 2 );
                append( sb, "See options.", 3 );
                append( sb, "Expression: ${keystore}", 3 );
                append( sb, "", 0 );

                append( sb, "sigalg", 2 );
                append( sb, "See options.", 3 );
                append( sb, "Expression: ${sigalg}", 3 );
                append( sb, "", 0 );

                append( sb, "skip (Default: false)", 2 );
                append( sb, "Set to true to disable the plugin.", 3 );
                append( sb, "Expression: ${keytool.skip}", 3 );
                append( sb, "", 0 );

                append( sb, "storepass", 2 );
                append( sb, "See options.", 3 );
                append( sb, "Expression: ${storepass}", 3 );
                append( sb, "", 0 );

                append( sb, "storetype", 2 );
                append( sb, "See options.", 3 );
                append( sb, "Expression: ${storetype}", 3 );
                append( sb, "", 0 );

                append( sb, "validity", 2 );
                append( sb, "See options.", 3 );
                append( sb, "Expression: ${validity}", 3 );
                append( sb, "", 0 );

                append( sb, "verbose (Default: false)", 2 );
                append( sb, "Enable verbose. See options.", 3 );
                append( sb, "Expression: ${verbose}", 3 );
                append( sb, "", 0 );

                append( sb, "workingDirectory (Default: ${basedir})", 2 );
                append( sb, "Where to execute the keytool command.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${keytool.workingdir}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "help".equals( goal ) )
        {
            append( sb, "keytool:help", 0 );
            append( sb, "Display help information on keytool-maven-plugin.\nCall\n\u00a0\u00a0mvn\u00a0keytool:help\u00a0-Ddetail=true\u00a0-Dgoal=<goal-name>\nto display parameter details.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "detail (Default: false)", 2 );
                append( sb, "If true, display all settable properties for each goal.", 3 );
                append( sb, "Expression: ${detail}", 3 );
                append( sb, "", 0 );

                append( sb, "goal", 2 );
                append( sb, "The name of the goal for which to show help. If unspecified, all goals will be displayed.", 3 );
                append( sb, "Expression: ${goal}", 3 );
                append( sb, "", 0 );

                append( sb, "indentSize (Default: 2)", 2 );
                append( sb, "The number of spaces per indentation level, should be positive.", 3 );
                append( sb, "Expression: ${indentSize}", 3 );
                append( sb, "", 0 );

                append( sb, "lineLength (Default: 80)", 2 );
                append( sb, "The maximum length of a display line, should be positive.", 3 );
                append( sb, "Expression: ${lineLength}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "import".equals( goal ) )
        {
            append( sb, "keytool:import", 0 );
            append( sb, "Deprecated. since 1.2, user now the importCertificate mojo instead.", 1 );
            if ( detail )
            {
                append( sb, "", 0 );
                append( sb, "Reads the certificate or certificate chain (where the latter is supplied in a PKCS#7 formatted reply) from the file cert_file, and stores it in the keystore entry identified by alias. Implemented as a wrapper around the SDK keytool -import command.\n-import\u00a0\u00a0\u00a0[-v]\u00a0[-protected]\n[-alias\u00a0<alias>]\n[-file\u00a0<file>]\n[-keypass\u00a0<keypass>]\n[-storepass\u00a0<storepass>]\n[-storetype\u00a0<storetype>]\n[-keystore\u00a0<keystore>]\nSee keystore documentation.", 1 );
            }
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "alias", 2 );
                append( sb, "See options.", 3 );
                append( sb, "Expression: ${alias}", 3 );
                append( sb, "", 0 );

                append( sb, "arguments", 2 );
                append( sb, "List of additional arguments to append to the keytool command line.", 3 );
                append( sb, "Expression: ${keytool.arguments}", 3 );
                append( sb, "", 0 );

                append( sb, "file", 2 );
                append( sb, "See options.", 3 );
                append( sb, "Expression: ${file}", 3 );
                append( sb, "", 0 );

                append( sb, "keypass", 2 );
                append( sb, "See options.", 3 );
                append( sb, "Expression: ${keypass}", 3 );
                append( sb, "", 0 );

                append( sb, "keystore", 2 );
                append( sb, "See options.", 3 );
                append( sb, "Expression: ${keystore}", 3 );
                append( sb, "", 0 );

                append( sb, "skip (Default: false)", 2 );
                append( sb, "Set to true to disable the plugin.", 3 );
                append( sb, "Expression: ${keytool.skip}", 3 );
                append( sb, "", 0 );

                append( sb, "storepass", 2 );
                append( sb, "See options.", 3 );
                append( sb, "Expression: ${storepass}", 3 );
                append( sb, "", 0 );

                append( sb, "storetype", 2 );
                append( sb, "See options.", 3 );
                append( sb, "Expression: ${storetype}", 3 );
                append( sb, "", 0 );

                append( sb, "useJREcacerts (Default: false)", 2 );
                append( sb, "Imports Cert in current Java Runtime lib/security/cacerts.", 3 );
                append( sb, "Expression: ${useJREcacerts}", 3 );
                append( sb, "", 0 );

                append( sb, "verbose (Default: false)", 2 );
                append( sb, "Enable verbose. See options.", 3 );
                append( sb, "Expression: ${verbose}", 3 );
                append( sb, "", 0 );

                append( sb, "workingDirectory (Default: ${basedir})", 2 );
                append( sb, "Where to execute the keytool command.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${keytool.workingdir}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "importCertificate".equals( goal ) )
        {
            append( sb, "keytool:importCertificate", 0 );
            append( sb, "To import a certificate into a keystore. Implemented as a wrapper around the SDK keytool -import (jdk 1.5) or keytool -importcert (jdk 1.6) command. See keystore documentation. Since version 1.2, this mojo replace the mojo import.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "alias", 2 );
                append( sb, "Alias name of the entry to process. See options.", 3 );
                append( sb, "Expression: ${alias}", 3 );
                append( sb, "", 0 );

                append( sb, "arguments", 2 );
                append( sb, "List of additional arguments to append to the keytool command line. Note: This parameter is left for compatibility reason but should be used at a last resort whenparameters are not found in dedicated mojo due to possible side-effects on parameters (see https://jira.codehaus.org/browse/MKEYTOOL-17)", 3 );
                append( sb, "Expression: ${keytool.arguments}", 3 );
                append( sb, "", 0 );

                append( sb, "file", 2 );
                append( sb, "Input file name. See options.", 3 );
                append( sb, "Expression: ${file}", 3 );
                append( sb, "", 0 );

                append( sb, "keypass", 2 );
                append( sb, "Key password. See options.", 3 );
                append( sb, "Expression: ${keypass}", 3 );
                append( sb, "", 0 );

                append( sb, "keystore", 2 );
                append( sb, "Keystore location. See options.", 3 );
                append( sb, "Expression: ${keystore}", 3 );
                append( sb, "", 0 );

                append( sb, "noprompt", 2 );
                append( sb, "Do not prompt. See options.", 3 );
                append( sb, "Expression: ${noprompt}", 3 );
                append( sb, "", 0 );

                append( sb, "passwordProtected", 2 );
                append( sb, "Password through protected mechanism. See options.", 3 );
                append( sb, "Expression: ${passwordProtected}", 3 );
                append( sb, "", 0 );

                append( sb, "providerarg", 2 );
                append( sb, "Provider argument. See options.", 3 );
                append( sb, "Expression: ${providerarg}", 3 );
                append( sb, "", 0 );

                append( sb, "providerclass", 2 );
                append( sb, "Provider class name. See options.", 3 );
                append( sb, "Expression: ${providerclass}", 3 );
                append( sb, "", 0 );

                append( sb, "providername", 2 );
                append( sb, "Provider name. See options.", 3 );
                append( sb, "Expression: ${providername}", 3 );
                append( sb, "", 0 );

                append( sb, "providerpath", 2 );
                append( sb, "Provider classpath. See options.", 3 );
                append( sb, "Expression: ${providerpath}", 3 );
                append( sb, "", 0 );

                append( sb, "skip (Default: false)", 2 );
                append( sb, "Set to true to disable the plugin.", 3 );
                append( sb, "Expression: ${keytool.skip}", 3 );
                append( sb, "", 0 );

                append( sb, "storepass", 2 );
                append( sb, "Keystore password. See options.", 3 );
                append( sb, "Expression: ${storepass}", 3 );
                append( sb, "", 0 );

                append( sb, "storetype", 2 );
                append( sb, "Keystore type. See options.", 3 );
                append( sb, "Expression: ${storetype}", 3 );
                append( sb, "", 0 );

                append( sb, "trustcacerts", 2 );
                append( sb, "Trust certificates from cacerts. See options.", 3 );
                append( sb, "Expression: ${trustcacerts}", 3 );
                append( sb, "", 0 );

                append( sb, "verbose (Default: false)", 2 );
                append( sb, "Enable verbose mode (in mojo and in keytool command). See options.", 3 );
                append( sb, "Expression: ${verbose}", 3 );
                append( sb, "", 0 );

                append( sb, "workingDirectory (Default: ${basedir})", 2 );
                append( sb, "Where to execute the keytool command.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${keytool.workingdir}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "importKeystore".equals( goal ) )
        {
            append( sb, "keytool:importKeystore", 0 );
            append( sb, "To import all entries of a keystore to another keystore. Implemented as a wrapper around the SDK keytool -importkeystore command. See keystore documentation.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "arguments", 2 );
                append( sb, "List of additional arguments to append to the keytool command line. Note: This parameter is left for compatibility reason but should be used at a last resort whenparameters are not found in dedicated mojo due to possible side-effects on parameters (see https://jira.codehaus.org/browse/MKEYTOOL-17)", 3 );
                append( sb, "Expression: ${keytool.arguments}", 3 );
                append( sb, "", 0 );

                append( sb, "destalias", 2 );
                append( sb, "Destination alias. See options.", 3 );
                append( sb, "Expression: ${destalias}", 3 );
                append( sb, "", 0 );

                append( sb, "destkeypass", 2 );
                append( sb, "Destination key password. See options.", 3 );
                append( sb, "Expression: ${destkeypass}", 3 );
                append( sb, "", 0 );

                append( sb, "destkeystore", 2 );
                append( sb, "Destination keystore name. See options.", 3 );
                append( sb, "Expression: ${destkeystore}", 3 );
                append( sb, "", 0 );

                append( sb, "destprovidername", 2 );
                append( sb, "Destination keystore provider name. See options.", 3 );
                append( sb, "Expression: ${destprovidername}", 3 );
                append( sb, "", 0 );

                append( sb, "deststorepass", 2 );
                append( sb, "Destination keystore password. See options.", 3 );
                append( sb, "Expression: ${deststorepass}", 3 );
                append( sb, "", 0 );

                append( sb, "deststoretype", 2 );
                append( sb, "Destination keystore type. See options.", 3 );
                append( sb, "Expression: ${deststoretype}", 3 );
                append( sb, "", 0 );

                append( sb, "noprompt", 2 );
                append( sb, "Do not prompt. See options.", 3 );
                append( sb, "Expression: ${noprompt}", 3 );
                append( sb, "", 0 );

                append( sb, "providerarg", 2 );
                append( sb, "Provider argument. See options.", 3 );
                append( sb, "Expression: ${providerarg}", 3 );
                append( sb, "", 0 );

                append( sb, "providerclass", 2 );
                append( sb, "Provider class name. See options.", 3 );
                append( sb, "Expression: ${providerclass}", 3 );
                append( sb, "", 0 );

                append( sb, "providerpath", 2 );
                append( sb, "Provider classpath. See options.", 3 );
                append( sb, "Expression: ${providerpath}", 3 );
                append( sb, "", 0 );

                append( sb, "skip (Default: false)", 2 );
                append( sb, "Set to true to disable the plugin.", 3 );
                append( sb, "Expression: ${keytool.skip}", 3 );
                append( sb, "", 0 );

                append( sb, "srcalias", 2 );
                append( sb, "Source alias. See options.", 3 );
                append( sb, "Expression: ${srcalias}", 3 );
                append( sb, "", 0 );

                append( sb, "srckeypass", 2 );
                append( sb, "Source key password. See options.", 3 );
                append( sb, "Expression: ${srckeypass}", 3 );
                append( sb, "", 0 );

                append( sb, "srckeystore", 2 );
                append( sb, "Source keystore name. See options.", 3 );
                append( sb, "Expression: ${srckeystore}", 3 );
                append( sb, "", 0 );

                append( sb, "srcprotected", 2 );
                append( sb, "Source keystore password protected. See options.", 3 );
                append( sb, "Expression: ${srcprotected}", 3 );
                append( sb, "", 0 );

                append( sb, "srcprovidername", 2 );
                append( sb, "Source keystore provider name. See options.", 3 );
                append( sb, "Expression: ${srcprovidername}", 3 );
                append( sb, "", 0 );

                append( sb, "srcstorepass", 2 );
                append( sb, "Source keystore password. See options.", 3 );
                append( sb, "Expression: ${srcstorepass}", 3 );
                append( sb, "", 0 );

                append( sb, "srcstoretype", 2 );
                append( sb, "Source keystore type. See options.", 3 );
                append( sb, "Expression: ${srcstoretype}", 3 );
                append( sb, "", 0 );

                append( sb, "verbose (Default: false)", 2 );
                append( sb, "Enable verbose mode (in mojo and in keytool command). See options.", 3 );
                append( sb, "Expression: ${verbose}", 3 );
                append( sb, "", 0 );

                append( sb, "workingDirectory (Default: ${basedir})", 2 );
                append( sb, "Where to execute the keytool command.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${keytool.workingdir}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "list".equals( goal ) )
        {
            append( sb, "keytool:list", 0 );
            append( sb, "To list entries in a keystore. Implemented as a wrapper around the SDK keytool -list (jdk 1.5) command. See keystore documentation.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "alias", 2 );
                append( sb, "Alias name of the entry to process. See options.", 3 );
                append( sb, "Expression: ${alias}", 3 );
                append( sb, "", 0 );

                append( sb, "arguments", 2 );
                append( sb, "List of additional arguments to append to the keytool command line. Note: This parameter is left for compatibility reason but should be used at a last resort whenparameters are not found in dedicated mojo due to possible side-effects on parameters (see https://jira.codehaus.org/browse/MKEYTOOL-17)", 3 );
                append( sb, "Expression: ${keytool.arguments}", 3 );
                append( sb, "", 0 );

                append( sb, "keystore", 2 );
                append( sb, "Keystore location. See options.", 3 );
                append( sb, "Expression: ${keystore}", 3 );
                append( sb, "", 0 );

                append( sb, "passwordProtected", 2 );
                append( sb, "Password through protected mechanism. See options.", 3 );
                append( sb, "Expression: ${passwordProtected}", 3 );
                append( sb, "", 0 );

                append( sb, "providerarg", 2 );
                append( sb, "Provider argument. See options.", 3 );
                append( sb, "Expression: ${providerarg}", 3 );
                append( sb, "", 0 );

                append( sb, "providerclass", 2 );
                append( sb, "Provider class name. See options.", 3 );
                append( sb, "Expression: ${providerclass}", 3 );
                append( sb, "", 0 );

                append( sb, "providername", 2 );
                append( sb, "Provider name. See options.", 3 );
                append( sb, "Expression: ${providername}", 3 );
                append( sb, "", 0 );

                append( sb, "providerpath", 2 );
                append( sb, "Provider classpath. See options.", 3 );
                append( sb, "Expression: ${providerpath}", 3 );
                append( sb, "", 0 );

                append( sb, "rfc", 2 );
                append( sb, "Output in RFC style. See options.", 3 );
                append( sb, "Expression: ${rfc}", 3 );
                append( sb, "", 0 );

                append( sb, "skip (Default: false)", 2 );
                append( sb, "Set to true to disable the plugin.", 3 );
                append( sb, "Expression: ${keytool.skip}", 3 );
                append( sb, "", 0 );

                append( sb, "storepass", 2 );
                append( sb, "Keystore password. See options.", 3 );
                append( sb, "Expression: ${storepass}", 3 );
                append( sb, "", 0 );

                append( sb, "storetype", 2 );
                append( sb, "Keystore type. See options.", 3 );
                append( sb, "Expression: ${storetype}", 3 );
                append( sb, "", 0 );

                append( sb, "verbose (Default: false)", 2 );
                append( sb, "Enable verbose mode (in mojo and in keytool command). See options.", 3 );
                append( sb, "Expression: ${verbose}", 3 );
                append( sb, "", 0 );

                append( sb, "workingDirectory (Default: ${basedir})", 2 );
                append( sb, "Where to execute the keytool command.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${keytool.workingdir}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "printCertificate".equals( goal ) )
        {
            append( sb, "keytool:printCertificate", 0 );
            append( sb, "To print the content of a certificate. Implemented as a wrapper around the SDK keytool -printcert command. See keystore documentation.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "arguments", 2 );
                append( sb, "List of additional arguments to append to the keytool command line. Note: This parameter is left for compatibility reason but should be used at a last resort whenparameters are not found in dedicated mojo due to possible side-effects on parameters (see https://jira.codehaus.org/browse/MKEYTOOL-17)", 3 );
                append( sb, "Expression: ${keytool.arguments}", 3 );
                append( sb, "", 0 );

                append( sb, "file", 2 );
                append( sb, "Input file name. See options.", 3 );
                append( sb, "Expression: ${file}", 3 );
                append( sb, "", 0 );

                append( sb, "jarfile", 2 );
                append( sb, "Signed jar file. See options.", 3 );
                append( sb, "Expression: ${jarfile}", 3 );
                append( sb, "", 0 );

                append( sb, "rfc", 2 );
                append( sb, "Output in RFC style. See options.", 3 );
                append( sb, "Expression: ${rfc}", 3 );
                append( sb, "", 0 );

                append( sb, "skip (Default: false)", 2 );
                append( sb, "Set to true to disable the plugin.", 3 );
                append( sb, "Expression: ${keytool.skip}", 3 );
                append( sb, "", 0 );

                append( sb, "sslserver", 2 );
                append( sb, "SSL server host and port. See options.", 3 );
                append( sb, "Expression: ${sslserver}", 3 );
                append( sb, "", 0 );

                append( sb, "verbose (Default: false)", 2 );
                append( sb, "Enable verbose mode (in mojo and in keytool command). See options.", 3 );
                append( sb, "Expression: ${verbose}", 3 );
                append( sb, "", 0 );

                append( sb, "workingDirectory (Default: ${basedir})", 2 );
                append( sb, "Where to execute the keytool command.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${keytool.workingdir}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "printCertificateRequest".equals( goal ) )
        {
            append( sb, "keytool:printCertificateRequest", 0 );
            append( sb, "To print the content of a certificate request. Implemented as a wrapper around the SDK keytool -printcertreq command. See keystore documentation.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "arguments", 2 );
                append( sb, "List of additional arguments to append to the keytool command line. Note: This parameter is left for compatibility reason but should be used at a last resort whenparameters are not found in dedicated mojo due to possible side-effects on parameters (see https://jira.codehaus.org/browse/MKEYTOOL-17)", 3 );
                append( sb, "Expression: ${keytool.arguments}", 3 );
                append( sb, "", 0 );

                append( sb, "file", 2 );
                append( sb, "Input file name. See options.", 3 );
                append( sb, "Expression: ${file}", 3 );
                append( sb, "", 0 );

                append( sb, "skip (Default: false)", 2 );
                append( sb, "Set to true to disable the plugin.", 3 );
                append( sb, "Expression: ${keytool.skip}", 3 );
                append( sb, "", 0 );

                append( sb, "verbose (Default: false)", 2 );
                append( sb, "Enable verbose mode (in mojo and in keytool command). See options.", 3 );
                append( sb, "Expression: ${verbose}", 3 );
                append( sb, "", 0 );

                append( sb, "workingDirectory (Default: ${basedir})", 2 );
                append( sb, "Where to execute the keytool command.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${keytool.workingdir}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "printCRLFile".equals( goal ) )
        {
            append( sb, "keytool:printCRLFile", 0 );
            append( sb, "To print the content of a CRL file. Implemented as a wrapper around the SDK keytool -printcrl command. See keystore documentation.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "arguments", 2 );
                append( sb, "List of additional arguments to append to the keytool command line. Note: This parameter is left for compatibility reason but should be used at a last resort whenparameters are not found in dedicated mojo due to possible side-effects on parameters (see https://jira.codehaus.org/browse/MKEYTOOL-17)", 3 );
                append( sb, "Expression: ${keytool.arguments}", 3 );
                append( sb, "", 0 );

                append( sb, "file", 2 );
                append( sb, "Input file name. See options.", 3 );
                append( sb, "Expression: ${file}", 3 );
                append( sb, "", 0 );

                append( sb, "skip (Default: false)", 2 );
                append( sb, "Set to true to disable the plugin.", 3 );
                append( sb, "Expression: ${keytool.skip}", 3 );
                append( sb, "", 0 );

                append( sb, "verbose (Default: false)", 2 );
                append( sb, "Enable verbose mode (in mojo and in keytool command). See options.", 3 );
                append( sb, "Expression: ${verbose}", 3 );
                append( sb, "", 0 );

                append( sb, "workingDirectory (Default: ${basedir})", 2 );
                append( sb, "Where to execute the keytool command.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${keytool.workingdir}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( getLog().isInfoEnabled() )
        {
            getLog().info( sb.toString() );
        }
    }

    /**
     * <p>Repeat a String <code>n</code> times to form a new string.</p>
     *
     * @param str String to repeat
     * @param repeat number of times to repeat str
     * @return String with repeated String
     * @throws NegativeArraySizeException if <code>repeat < 0</code>
     * @throws NullPointerException if str is <code>null</code>
     */
    private static String repeat( String str, int repeat )
    {
        StringBuffer buffer = new StringBuffer( repeat * str.length() );

        for ( int i = 0; i < repeat; i++ )
        {
            buffer.append( str );
        }

        return buffer.toString();
    }

    /** 
     * Append a description to the buffer by respecting the indentSize and lineLength parameters.
     * <b>Note</b>: The last character is always a new line.
     * 
     * @param sb The buffer to append the description, not <code>null</code>.
     * @param description The description, not <code>null</code>.
     * @param indent The base indentation level of each line, must not be negative.
     */
    private void append( StringBuffer sb, String description, int indent )
    {
        for ( Iterator it = toLines( description, indent, indentSize, lineLength ).iterator(); it.hasNext(); )
        {
            sb.append( it.next().toString() ).append( '\n' );
        }
    }

    /** 
     * Splits the specified text into lines of convenient display length.
     * 
     * @param text The text to split into lines, must not be <code>null</code>.
     * @param indent The base indentation level of each line, must not be negative.
     * @param indentSize The size of each indentation, must not be negative.
     * @param lineLength The length of the line, must not be negative.
     * @return The sequence of display lines, never <code>null</code>.
     * @throws NegativeArraySizeException if <code>indent < 0</code>
     */
    private static List toLines( String text, int indent, int indentSize, int lineLength )
    {
        List lines = new ArrayList();

        String ind = repeat( "\t", indent );
        String[] plainLines = text.split( "(\r\n)|(\r)|(\n)" );
        for ( int i = 0; i < plainLines.length; i++ )
        {
            toLines( lines, ind + plainLines[i], indentSize, lineLength );
        }

        return lines;
    }

    /** 
     * Adds the specified line to the output sequence, performing line wrapping if necessary.
     * 
     * @param lines The sequence of display lines, must not be <code>null</code>.
     * @param line The line to add, must not be <code>null</code>.
     * @param indentSize The size of each indentation, must not be negative.
     * @param lineLength The length of the line, must not be negative.
     */
    private static void toLines( List lines, String line, int indentSize, int lineLength )
    {
        int lineIndent = getIndentLevel( line );
        StringBuffer buf = new StringBuffer( 256 );
        String[] tokens = line.split( " +" );
        for ( int i = 0; i < tokens.length; i++ )
        {
            String token = tokens[i];
            if ( i > 0 )
            {
                if ( buf.length() + token.length() >= lineLength )
                {
                    lines.add( buf.toString() );
                    buf.setLength( 0 );
                    buf.append( repeat( " ", lineIndent * indentSize ) );
                }
                else
                {
                    buf.append( ' ' );
                }
            }
            for ( int j = 0; j < token.length(); j++ )
            {
                char c = token.charAt( j );
                if ( c == '\t' )
                {
                    buf.append( repeat( " ", indentSize - buf.length() % indentSize ) );
                }
                else if ( c == '\u00A0' )
                {
                    buf.append( ' ' );
                }
                else
                {
                    buf.append( c );
                }
            }
        }
        lines.add( buf.toString() );
    }

    /** 
     * Gets the indentation level of the specified line.
     * 
     * @param line The line whose indentation level should be retrieved, must not be <code>null</code>.
     * @return The indentation level of the line.
     */
    private static int getIndentLevel( String line )
    {
        int level = 0;
        for ( int i = 0; i < line.length() && line.charAt( i ) == '\t'; i++ )
        {
            level++;
        }
        for ( int i = level + 1; i <= level + 4 && i < line.length(); i++ )
        {
            if ( line.charAt( i ) == '\t' )
            {
                level++;
                break;
            }
        }
        return level;
    }
}
